package org.jboss.testmdbconcurrency;

import javax.ejb.ActivationConfigProperty;
import javax.ejb.MessageDriven;

import javax.jms.Message;
import javax.jms.MessageListener;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

@MessageDriven(name = "MyMDB", activationConfig = { @ActivationConfigProperty(propertyName = "destinationType", propertyValue = "javax.jms.Queue"),
		@ActivationConfigProperty(propertyName = "destination", propertyValue = Constants.QUEUE_PATH_AND_NAME),
		@ActivationConfigProperty(propertyName = "acknowledgeMode", propertyValue = "Auto-acknowledge") })
public class MyMDB implements MessageListener {

	private static final Logger log = LoggerFactory.getLogger(MyMDB.class);

	@Override
	public void onMessage(Message message) {

		try {

			// Simply log the message name, then forever sleep
			String myMessageId = message.getStringProperty(Constants.MESSAGE_NAME_PROPERTY);
			log.info("Message received with name {}", myMessageId);

			Thread.sleep(Long.MAX_VALUE);

		} catch (Throwable t) {
			log.error(t.getMessage(), t);
		}
	}

}
